 app.LoadPlugin("Multos");

var mult;

//Called when application is started.
function OnStart()
{
	//Check wifi is enabled.
	var ip = app.GetIPAddress();
	if( ip == "0.0.0.0" ) { 
		alert( "Please Enable Wi-Fi" ); 
		app.Exit();
	}
	//Create a layout with objects vertically centered.
	lay = app.CreateLayout( "linear", "VCenter,FillXY" );

    // Add MULTOS Logo
    logo = app.CreateImage("Img/MULTOS-Emboss-Web.png",0.4,-1);
    lay.AddChild(logo);
    
    // Add a tag line
    tagline = app.CreateText("Card Reader for Android");
    tagline.SetTextColor("cyan");
    tagline.SetTextSize(22);
    lay.AddChild(tagline);
    
	// Add label to display the IP Address
	var s = "IP Address: " + ip;
	txt = app.CreateText( s, 0.8, 0.1, "Left" );
	txt.SetTextSize(16);
	lay.AddChild( txt );
	
	// Add text for incoming APDUs
    capdutitle = app.CreateText( "Command APDU", 0.8, 0.05, "Left" );
    capdutitle.SetTextColor("cyan");
	lay.AddChild( capdutitle );	
    capdu = app.CreateText( "", 0.8, 0.3, "Left,MultiLine" );
	lay.AddChild( capdu );
	
	// Add text for reply APDU
    rapdutitle = app.CreateText( "Response", 0.8, 0.05, "Left" );
    rapdutitle.SetTextColor("cyan");
	lay.AddChild( rapdutitle );		
    rapdu = app.CreateText( "", 0.8, 0.3, "Left,MultiLine" );
	lay.AddChild( rapdu );
	
	//Add layout to app.	
	app.AddLayout( lay );

    // Set up MULTOS plugin
    mult = app.CreateMultos();
    mult.SetCallbacks(DeviceDiscovered,DeviceRemoved);
    
	//Create and run web server.
	serv = app.CreateWebServer( 8080, "Upload" );
	//serv.SetFolder( "/sdcard/DroidScript" );
	serv.AddServlet( "/message", OnServlet );
	serv.Start();
}

//Handle servlet requests.
function OnServlet( request, info )
{
    var resp = "";
    var resptext = "";
    
    // Check to see if device present
    if(mult.DeviceType(null) == 0)
    {
        app.ShowPopup("No card present!");
        resptext = "0000";
    }
    else if(request.msg == "reset")
    {
        mult.ResetDevice();
        resptext = mult.GetHistoricalBytes();
    }
    else
    {
        capdu.SetText(request.msg);
        resp = mult.SendCommand(request.msg,null);
        resptext = resp.responseData + resp.responseStatus;
        rapdu.SetText(resptext);
    }
	serv.SetResponse( resptext );
	//app.ShowPopup(  info.remoteAddress + " says: " + request.msg );
}

function DeviceDiscovered()
{
  app.ShowPopup ("Card found.");
}

function DeviceRemoved()
{
  app.ShowPopup ("Card removed!");
}